import clr
import abc
from PythonAbstractBaseClass import Door

class Room(object):
    def __init__(self, door):
        self.door = door

    def open(self):
        self.door.open()

    def close(self):
        self.door.close()

    def is_open(self):
        return self.door.is_open()
        
class StringDoor(Door):
    def __init__(self):
        self.status = "closed"
        
    def is_open(self):
        return self.status == "open"
        
    def toggle(self):
        if self.status == "open":
            self.status = "closed"
        else:
            self.status = "open"

class BooleanDoor(Door):
    def __init__(self):
        self.status = True

    def is_open(self):
        return self.status
        
    def toggle(self):
        self.status = not (self.status)

sdoor = StringDoor()
bdoor = BooleanDoor()
sroom = Room(sdoor)
broom = Room(bdoor)
        